#include <amxmodx>
#include <easy_http>

#define PLUGIN "Server Web Communication"
#define VERSION "1.0"
#define AUTHOR "EFFEX"

#define URL "http://www.yourwebsite.com"

new g_szServerIP[35]
new g_szMapName[32]
new g_iMaxPlayers
new g_iScore[2]

public plugin_init() 
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	g_iMaxPlayers = get_maxplayers()
	
	register_event("SendAudio", "event_TerroristsWin","a", "2&%!MRAD_terwin") 
	register_event("SendAudio", "event_CTWin","a", "2&%!MRAD_ctwin")  
	
	register_logevent("roundRestart", 2, "1&Restart_Round_", "1=Game_Commencing")
	
	get_user_ip(0, g_szServerIP, charsmax(g_szServerIP), false)
	get_mapname(g_szMapName, charsmax(g_szMapName))
	
	set_task(1.0, "getServerValidity")
}

public roundRestart()
{
	g_iScore[0] = g_iScore[1] = 0
}

public event_TerroristWin()
{
	g_iScore[0]++
}

public event_CTWin()
{
	g_iScore[0]++
}

public getServerValidity()
{
	new EzHttpOptions:iOpt = ezhttp_create_options()
	ezhttp_get(fmt("%s/registration.php?ip=%s", URL, g_szServerIP), "HTTP_ServerLicense", iOpt)
}

public HTTP_ServerLicense(EzHttpRequest:request_id)
{
	new szResponse[90]
	if(ezhttp_get_error_code(request_id))
	{
		ezhttp_get_data(request_id, szResponse, charsmax(szResponse))
		log_to_file("server_webcomm.log", "Web API error response: %s.", szResponse)
		return
	}
	
	ezhttp_get_data(request_id, szResponse, charsmax(szResponse))
	if(equal(szResponse, "yes"))
	{
		updateServerStatus()
		set_task(60.0, "updateServerStatus", .flags = "b")
	}
	else
	{
		log_to_file("server_webcomm.log", "This server is not registered.")
	}
}

public updateServerStatus()
{
	new szServerName[55]
	get_cvar_string("hostname", szServerName, charsmax(szServerName))
	
	new szModifiedURL[256]
	formatex
	(
		szModifiedURL, 
		charsmax(szModifiedURL),
		"%s/status.php?map=%s&server=%s&ip=%s&players=%d&max=%d&scoret=%d&scorect=%d", 
		URL,
		g_szMapName,
		szServerName,
		g_szServerIP,
		getPlayersNum(),
		g_iMaxPlayers,
		g_iScore[0],
		g_iScore[1]
	)
	
	replace_all(szModifiedURL, charsmax(szModifiedURL), " ", "[DASH]")
	replace_all(szModifiedURL, charsmax(szModifiedURL), "#", "[HASHTAG]")
	
	new EzHttpOptions:iOpt = ezhttp_create_options()
	ezhttp_get
	(
		szModifiedURL,
		"HTTP_UpdateServer", 
		iOpt
	)
}

public HTTP_UpdateServer(EzHttpRequest:request_id)
{
	new szResponse[90]
	if(ezhttp_get_error_code(request_id))
	{
		ezhttp_get_data(request_id, szResponse, charsmax(szResponse))
		log_to_file("server_webcomm.log", "Web API error response: %s.", szResponse)
		return
	}
	ezhttp_get_data(request_id, szResponse, charsmax(szResponse))
	log_to_file("server_webcomm.log", "Web API response: %s.", szResponse)
}

public getPlayersNum()
{
	new iPlayers[32], iNum
	get_players(iPlayers, iNum, "ch")
	return iNum
}
