<?php
$fileName = 'serversInfo.json';

$mapName = filter_input(INPUT_GET, 'map', FILTER_SANITIZE_STRING);
$serverName = str_replace('[HASHTAG]', '#', filter_input(INPUT_GET, 'server', FILTER_SANITIZE_STRING));
$serverIP = filter_input(INPUT_GET, 'ip', FILTER_SANITIZE_STRING);
$playersNum = filter_input(INPUT_GET, 'players', FILTER_SANITIZE_STRING);
$playersMax = filter_input(INPUT_GET, 'max', FILTER_SANITIZE_STRING);
$scoreT = filter_input(INPUT_GET, 'scoret', FILTER_SANITIZE_STRING);
$scoreCT = filter_input(INPUT_GET, 'scorect', FILTER_SANITIZE_STRING);

if($serverIP !== null 
&& $serverName !== null 
&& $mapName !== null 
&& $playersNum !== null
&& $playersMax !== null 
&& $scoreT !== null 
&& $scoreCT !== null) {
    $serverData = [
        'server' => str_replace('[DASH]', ' ', $serverName),
        'map' => $mapName,
        'players' => $playersNum,
        'playersmax' => $playersMax,
        'ip' => $serverIP,
        'scoret' => $scoreT,
        'scorect' => $scoreCT
    ];

    $existingData = file_exists($fileName) ? json_decode(file_get_contents($fileName), true) : [];
    $existingData[$serverIP] = $serverData;
    $jsonData = json_encode($existingData, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE);

    if ($jsonData !== false) {
        if (file_put_contents($fileName, $jsonData) !== false) {
            echo "Server information has been successfully updated.";
        } else {
            echo "Failed to save server information to file.";
        }
    } else {
        echo "Failed to encode server information to JSON format.";
    }
} else {
    echo "Invalid input parameters. Please provide all required parameters.";
}
?>